package console

import (
	"bufio"
	"context"
	"doc-service/domain/entity/serversitemicros/docserverproject"
	"doc-service/domain/service"
	"doc-service/infra/db"
	"fmt"
	"gitlab.galaxy-immi.com/Backend-group/go-com/third/log"
	"os"
	"strings"
	"time"
)

func DoAliData() {
	fmt.Println("开始刷新请求...")

	ctx := context.Background()
	// 启动一个协程来执行定时任务 20秒一次
	ticker := time.NewTicker(5 * time.Second)
	defer ticker.Stop()

	go func() {
		for {
			select {
			case <-ticker.C:
				i := toDoData(ctx)
				if i == 0 {
					fmt.Println("没有数据: " + time.Now().Format("2006-01-02 15:04:05"))
				}
			}
		}
	}()

	// 监听命令行输入
	reader := bufio.NewReader(os.Stdin)
	for {
		text, _ := reader.ReadString('\n')
		text = strings.TrimSpace(text)

		if text == "exit" {
			fmt.Println("Exiting process...")
			os.Exit(0)
		}
	}
}

//获取数据

func toDoData(c context.Context) int8 {
	projectData, err := db.GetServerSiteMicrosDB().DocServerProject.Query().Where(
		docserverproject.StatusEQ(0),
	).All(c)

	if err != nil {
		return 0
	}

	if len(projectData) <= 0 {
		return 0
	}

	for _, item := range projectData {
		docService := &service.DocServiceService{}
		ali := docService.DoConversionToAli(c, item.ID)
		if ali {
			_, errUpdate := db.GetServerSiteMicrosDB().DocServerProject.UpdateOneID(item.ID).SetStatus(1).Save(c)
			if errUpdate != nil {
				log.Info("修改状态出错" + errUpdate.Error())
				continue
			}
		}
		log.Info("脚本请求阿里文件转换完成: " + string(item.ID))
		fmt.Printf("脚本请求阿里文件转换完成:   %d\n", item.ID)
	}
	return 1
}
